import { HttpParams, Http } from '../contracts/http-params.js';
import { HttpProps } from '../contracts/http-props.js';
import { HttpRequestClient, HttpRequest } from '../contracts/http-request.js';
import { HttpResponse } from '../contracts/http-response.js';
import { HttpGetClient, HttpGet } from '../contracts/verbs/http-get-client.js';
import { HttpDeleteClient, HttpDelete } from '../contracts/verbs/http-delete-client.js';
import { HttpPatchClient, HttpPatch } from '../contracts/verbs/http-patch-client.js';
import { HttpPostClient, HttpPost } from '../contracts/verbs/http-post-client.js';
import { HttpPutClient, HttpPut } from '../contracts/verbs/http-put-client.js';
import '../contracts/http-headers.js';

declare class SuperHttpClientAdapter implements HttpProps, HttpParams, HttpGetClient, HttpPostClient, HttpPatchClient, HttpPutClient, HttpDeleteClient, HttpRequestClient {
    private readonly THIRTY_SECONDS;
    private readonly _timeout;
    private readonly axiosInstance;
    constructor(input: HttpProps);
    get baseURL(): string;
    set baseURL(baseURL: string);
    get timeout(): number;
    resolveRouteParams(input: Http.RouteInput): Http.RouteOutput;
    resolveQueryParams(input: Http.QueryInput): Http.QueryOutput;
    private resolveURL;
    private buildHttpSuccessResponse;
    get<R = any>(input: HttpGet.Input): Promise<HttpResponse>;
    post<D = any, R = any>(input: HttpPost.Input<D>): Promise<HttpResponse>;
    patch<D = any, R = any>(input: HttpPatch.Input<D>): Promise<HttpResponse>;
    put<D = any, R = any>(input: HttpPut.Input<D>): Promise<HttpResponse>;
    delete<D = any, R = any>(input: HttpDelete.Input): Promise<HttpResponse>;
    request<D = any, R = any>(input: HttpRequest.Input<D>): Promise<HttpResponse>;
}

export { SuperHttpClientAdapter };
