import { HttpHeaders } from './http-headers.js';
import { Http } from './http-params.js';
import { HttpResponse } from './http-response.js';

declare namespace HttpRequest {
    type Method = 'GET' | 'POST' | 'PATCH' | 'PUT' | 'DELETE';
    type Input<D> = {
        method: Method;
        timeout?: number;
        baseURL?: string;
        url: string;
        data?: D;
        headers?: HttpHeaders;
        routeParams?: Http.Route[];
        queryParams?: Http.Query[];
    };
}
interface HttpRequestClient {
    request<D = any, R = any>(input: HttpRequest.Input<D>): Promise<HttpResponse<R>>;
}

export { HttpRequest, HttpRequestClient };
