import { HttpHeaders } from '../http-headers.js';
import { Http } from '../http-params.js';
import { HttpResponse } from '../http-response.js';

declare namespace HttpDelete {
    type Input = {
        timeout?: number;
        baseURL?: string;
        url: string;
        headers?: HttpHeaders;
        routeParams?: Http.Route[];
        queryParams?: Http.Query[];
    };
}
interface HttpDeleteClient {
    delete<R = any>(input: HttpDelete.Input): Promise<HttpResponse<R>>;
}

export { HttpDelete, HttpDeleteClient };
