import { HttpHeaders } from '../http-headers.js';
import { Http } from '../http-params.js';
import { HttpResponse } from '../http-response.js';

declare namespace HttpPost {
    type Input<D> = {
        timeout?: number;
        baseURL?: string;
        url: string;
        data: D;
        headers?: HttpHeaders;
        routeParams?: Http.Route[];
        queryParams?: Http.Query[];
    };
}
interface HttpPostClient {
    post<D = any, R = any>(input: HttpPost.Input<D>): Promise<HttpResponse<R>>;
}

export { HttpPost, HttpPostClient };
